#include "clock.h"

extern char **about_icon_xpm;

static char *about_label_text = \
"Programmed by:  Oleg Katsitadze\n\n\
in the year of two thousand and three";

/* GTK_WIDGET(data) should be a pointer to dialog widget */
static void ok_clicked(GtkWidget *widget, gpointer data)
{
    gtk_widget_destroy(GTK_WIDGET(data));

    return;
}

void show_about_dialog(GtkWidget *parent)
{
    GtkWidget *dialog;
    GtkWidget *widget;
    GtkWidget *box;
    GdkPixmap *icon;
    GdkBitmap *mask;
    GtkRequisition requisition;

    dialog = gtk_dialog_new();
    /* Cannot shrink, grow, or autoshrink */
    gtk_window_set_policy( GTK_WINDOW(dialog), FALSE, FALSE, FALSE );
    gtk_window_set_transient_for( GTK_WINDOW(dialog), GTK_WINDOW(parent) );
    gtk_window_set_title( GTK_WINDOW(dialog), "About" );
    gtk_box_set_homogeneous( GTK_BOX(GTK_DIALOG(dialog)->action_area), TRUE );
    gtk_container_set_border_width( GTK_CONTAINER(GTK_DIALOG(dialog)->action_area), 0 );
    gtk_box_set_spacing( GTK_BOX(GTK_DIALOG(dialog)->action_area), 10 );
    gtk_container_set_border_width( GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), 10 );
    gtk_box_set_spacing( GTK_BOX(GTK_DIALOG(dialog)->vbox), 10 );

    box = gtk_hbox_new(FALSE, 10);
    /* Icon widget */
    icon = gdk_pixmap_create_from_xpm_d( parent->window, &mask,
                                         &parent->style->bg[GTK_STATE_NORMAL],
                                         about_icon_xpm );
    widget = gtk_pixmap_new(icon, mask);
    gtk_widget_show(widget);
    gtk_box_pack_start( GTK_BOX(box), widget, TRUE, FALSE, 0 );
    /* Label */
    widget = gtk_label_new(about_label_text);
    gtk_widget_show(widget);
    gtk_box_pack_start( GTK_BOX(box), widget, TRUE, FALSE, 0 );
    gtk_widget_show(box);
    gtk_box_pack_start( GTK_BOX(GTK_DIALOG(dialog)->vbox), box, TRUE, TRUE, 0 );

    /* `OK' button */
    widget = gtk_button_new_with_label("OK");
    gtk_box_pack_end( GTK_BOX(GTK_DIALOG(dialog)->action_area), widget, FALSE, FALSE, 0 );
    gtk_signal_connect( GTK_OBJECT(widget), "clicked",
                        GTK_SIGNAL_FUNC(ok_clicked),
                        (gpointer) dialog );
    GTK_WIDGET_SET_FLAGS( widget, GTK_CAN_DEFAULT );
    gtk_widget_grab_default(widget);
    /* Adjust size of the button */
    gtk_widget_size_request(widget, &requisition);
    requisition.width *= BUTTON_WIDTH_RATIO;
    requisition.height *= BUTTON_HEIGHT_RATIO;
    gtk_widget_set_usize( widget, requisition.width, requisition.height );
    gtk_widget_show(widget);

    gtk_widget_show(dialog);

    return;
}



/*
 * Local variables:
 * compile-command: "make -k && ./clockgtk"
 * End:
 */
