#ifndef __KYBOS_H__
#define __KYBOS_H__
#include <stdio.h> /* FILE */
#include <gdk/gdk.h>

typedef struct _Point {
    double x;
    double y;
    double z;
} Point;

typedef struct _Triangle {
    int p1; /* these are indexes... */
    int p2; /* ...into array of... */
    int p3; /* ...points */
    int color; /* index into array of GC's */
    struct _Triangle *next;
} Triangle;

typedef struct _Kybos {
    int       projection;   /* 0 - parallel; 1 - perspective */
    Point     viewpoint;
    double    screen;       /* z-coordinate of the screen in view coordinates */
    int       num_vertices;
    Point    *vertices;     /* array of num_vertices vertices */
    Triangle *triangles;    /* triangulated faces */
    GdkGC   **gcs;
    int       incr_x;       /* these are increments... */
    int       incr_y;       /* ...for movement of object along... */
    int       incr_z;       /* ...all the world axes... */
    int       incr_s;       /* ...and movement of screen along z view axis */
} Kybos;


extern char  *progname;
extern void  *xmalloc(int size);
extern Kybos *read_data(FILE *stream);
extern void   draw_object(GdkDrawable *drawable, Kybos *obj);



#endif /* __KYBOS_H__ */
