#include "threads.h"

int mouse_getbutton_emulated(void)
{
    int button = 0;

    if( keyboard_keypressed(SCANCODE_LEFTSHIFT) ||
        keyboard_keypressed(SCANCODE_RIGHTSHIFT)   )
        button |= MOUSE_LEFTBUTTON;

    if( keyboard_keypressed(SCANCODE_LEFTCONTROL) ||
        keyboard_keypressed(SCANCODE_RIGHTCONTROL)   )
        button |= MOUSE_RIGHTBUTTON;

    if( keyboard_keypressed(SCANCODE_Q) ||
        keyboard_keypressed(SCANCODE_X) ||
        keyboard_keypressed(SCANCODE_ESCAPE) )
        not_done_yet = 0;

    return button;
}


int delta_init = DEFAULT_DELTA_INIT;
int delta_max  = DEFAULT_DELTA_MAX;
int dx = 0, dy = 0;

int mouse_getx_emulated(int x)
{
    int still_moving = 0;

    dx += delta_init;

    /* Right */
    if( keyboard_keypressed(SCANCODE_L)                ||
        keyboard_keypressed(SCANCODE_F)                ||
        keyboard_keypressed(SCANCODE_CURSORBLOCKRIGHT) ||
        keyboard_keypressed(SCANCODE_CURSORRIGHT)      ||
        keyboard_keypressed(SCANCODE_CURSORUPRIGHT)    ||
        keyboard_keypressed(SCANCODE_CURSORDOWNRIGHT)     ) {
        x += dx;
        still_moving = 1;
    }

    /* Left */
    if( keyboard_keypressed(SCANCODE_H)               ||
        keyboard_keypressed(SCANCODE_B)               ||
        keyboard_keypressed(SCANCODE_CURSORBLOCKLEFT) ||
        keyboard_keypressed(SCANCODE_CURSORLEFT)      ||
        keyboard_keypressed(SCANCODE_CURSORUPLEFT)    ||
        keyboard_keypressed(SCANCODE_CURSORDOWNLEFT)     ) {
        x -= dx;
        still_moving = 1;
    }

/*     if ( keyboard_keypressed(SCANCODE_KEYPAD5) ) */
/*         x = scr_width/2; */

    /* If not moving the pointer anymore, reset dx; otherwise, check
     * delta_max */
    if ( !still_moving )
        dx = 0;
    else if ( dx > delta_max )
        dx = delta_max;

    /* Check screen boundaries */
    if ( x < 0 ) {
        x = 0;
        dx = 0;
    } else if ( x >= scr_width ) {
        x = scr_width - 1;
        dx = 0;
    }

    return x;
}

int mouse_gety_emulated(int y)
{
    int still_moving = 0;

    dy += delta_init;

    /* Down */
    if( keyboard_keypressed(SCANCODE_J)               ||
        keyboard_keypressed(SCANCODE_N)               ||
        keyboard_keypressed(SCANCODE_CURSORBLOCKDOWN) ||
        keyboard_keypressed(SCANCODE_CURSORDOWN)      ||
        keyboard_keypressed(SCANCODE_CURSORDOWNRIGHT) ||
        keyboard_keypressed(SCANCODE_CURSORDOWNLEFT)     ) {
        y += dy;
        still_moving = 1;
    }

    /* Up */
    if( keyboard_keypressed(SCANCODE_K)             ||
        keyboard_keypressed(SCANCODE_P)             ||
        keyboard_keypressed(SCANCODE_CURSORBLOCKUP) ||
        keyboard_keypressed(SCANCODE_CURSORUP)      ||
        keyboard_keypressed(SCANCODE_CURSORUPLEFT)  ||
        keyboard_keypressed(SCANCODE_CURSORUPRIGHT)    ) {
        y -= dy;
        still_moving = 1;
    }

/*     if ( keyboard_keypressed(SCANCODE_KEYPAD5) ) */
/*         y = scr_height/2; */

    /* If not moving the pointer anymore, reset dy; otherwise, check
     * delta_max */
    if ( !still_moving )
        dy = 0;
    else if ( dy > delta_max )
        dy = delta_max;

    /* Check screen boundaries */
    if ( y < 0 ) {
        y = 0;
        dy = 0;
    } else if ( y >= scr_height ) {
        y = scr_height - 1;
        dy = 0;
    }

    return y;
}



/*
 * Local variables:
 * compile-command: "make -k"
 * End:
 */
